unit Mainform;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, activeds_tlb,
  StdCtrls, comobj, activex;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses AdsHlp;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var Container : IADsContainer;
    NewObject : IADs;
    User      : IADsUser;
    hr        : HREsult;
begin
  // Bind to the container.
  hr := ADsGetObject('WinNT://AGNI',IADsContainer,
              Container);
  if Failed(hr) then Exit;

  // Create the new Active Directory Service Interfaces User object.
  NewObject := Container.Create('User','ActiveDirectoryUser') as IADs;

  // Get the IADsUser interface from the user object.
  NewObject.QueryInterface(IID_IADsUser, User);

  // Set password.
  User.SetPassword('Borland');

  // Complete the operation to create the object.
  User.SetInfo;

  // Cleanup.
  Container._Release;
  NewObject._Release;
  User._Release;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  CoInitialize(nil);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  CoUninitialize;
end;

end.
