(************************************************************
Author: Deepak Shenoy
        shenoy@agnisoft.com
Copyright (C) 2000 Agni Software Pvt. Ltd.
All Rights Reserved.
http://www.agnisoft.com

Description:
This project demonstrates a simple user manager using ADSI
It was converted from the "UsrMgr" sample (Visual Basic sample) in the
ADSI SDK.

The code demonstrates the use of ADSI in Delphi. As this example demonstrates,
ADSI is very simple to use in Delphi. I have tended to use OleVariants in some
places. It may not be very advisable, but I have found that speed is faster than
VB's code by a large factor.

This file is licensed to you as given in the readme.txt file accompanying this archive.
In short, you may redistribute this code as is, or with modifications - and use it
freely in any commercial applications. But you may not license this code or any
modifications to it under the GNU Public License (GPL).
(Agni Software does not support the GPL)
********************************************************)
program UserManager;

uses
  Forms,
  UserForm in 'UserForm.pas' {frmUser},
  adshlp in '..\Common\adshlp.pas',
  ActiveDs_TLB in '..\Common\ActiveDs_TLB.pas',
  ChooseDomain in 'ChooseDomain.pas' {frmChooseDomain},
  GroupForm in 'GroupForm.pas' {frmGroup},
  GroupListForm in 'GroupListForm.pas' {frmGroupList};

{$R *.RES}

begin
  Application.Initialize;
  Application.CreateForm(TfrmUser, frmUser);
  Application.CreateForm(TfrmChooseDomain, frmChooseDomain);
  Application.Run;
end.
